
import { apiRequest } from '../request';

const api="/DataObjApi";

export default {
  namespace: 'DataObj',

  state: {
    list: [],
    data:{
      list: [],
      pagination: {},
    },
    code:{
      list: [],
      pagination: {},
    }
  
  },

  effects: {
    
    *getExportInfo({ payload, callback }, { call, put }) {
      const response = yield call(apiRequest,api+"/getExportInfo" ,payload);
      if(!response){yield put({type: 'nom'});return }
     
      yield put({
        type: 'nom',
        payload: response,
      });
      if (callback) callback(response);
    },
    *changeCatalogue({ payload, callback }, { call, put }) {
      const response = yield call(apiRequest,api+"/changeCatalogue" ,payload);
      if(!response){yield put({type: 'nom'});return }
     
      yield put({
        type: 'nom',
        payload: response,
      });
      if (callback) callback(response);
    },
    *find({ payload, callback }, { call, put }) {
      const response = yield call(apiRequest,api+"/find" ,payload);
      if(!response){yield put({type: 'nom'});return }
     
      yield put({
        type: 'nom',
        payload: response,
      });
      if (callback) callback(response);
    },
    *add({ payload, callback }, { call, put }) {
      const response = yield call(apiRequest,api+"/add" ,payload);
      if(!response){yield put({type: 'nom'});return }
     
      yield put({
        type: 'nom',
        payload: response,
      });
      if (callback) callback(response);
    },*fetch({ payload, callback }, { call, put }) {
        
      const response = yield call(apiRequest,api+"/getPage" ,payload);
      if(!response){yield put({type: 'nom'});return }
      yield put({
        type: 'page',
        payload: {...response,isMain:payload.isMain},
      });
      
    },*remove({ payload, callback }, { call, put }) {
      const response = yield call(apiRequest,api+"/remove" ,payload);
      if(!response){yield put({type: 'nom'});return }
      yield put({
        type: 'nom',
        payload: response,
      });
      if(callback){
        callback()
      }
      
    },*open({ payload, callback }, { call, put }) {
      
      const response = yield call(apiRequest,api+"/open" ,payload);
      if(!response){yield put({type: 'nom'});return }
      yield put({
        type: 'nom',
        payload: response,
      });
      if(callback){
        callback()
      }
      
    },
    *createTabel({payload,callback},{call,put}){
      const response = yield call(apiRequest,api+"/createTable",payload);
      if(!response){yield put({type: 'nom'});return }
      yield put({
        type: 'nom',
        payload: response,
      });
      if(callback){
        callback()
      }
    }
 
  },

  reducers: {
    list(state, action) {
      return {
        ...state,
        list: action.payload,
      };
    },
    page(state, { payload }) {
      if(payload.isMain){
        return {
          ...state,
          data:{
            list: payload.rows,
            pagination: {
              current:payload.pageNo,
              pageSize:payload.pageSize,
              total:payload.total,
            },
          }
        };
      }else{
        return {
          ...state,
          code:{
            list: payload.rows,
            pagination: {
              current:payload.pageNo,
              pageSize:payload.pageSize,
              total:payload.total,
            },
          }
        };
      }
     
    },
    nom(state, action) {
      return {...state };
      
   
    },
  },
};
